{

    /* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *\
    *                                                                 *
    *   ScanFake 1.2                                                  *
    *   Copyright  2004 Sebastian Pipping <webmaster@hartwork.org>   *
    *                                                                 *
    *   --> http://www.hartwork.org                                   *
    *                                                                 *
    *                                                                 *
    *   This source code is released under LGPL.                      *
    *   See LGPL.txt for details.                        2001-11-13   *
    *                                                                 *
    \* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

}

PROGRAM scanfake;

USES crt;


PROCEDURE line( y : BYTE );
  VAR
    i : BYTE;

  BEGIN
    GOTOXY( 6, y );
    FOR i := 1 TO 68 DO
      WRITE( #196 );

  END;


PROCEDURE progressbar( percent : BYTE );
  VAR
    full : BYTE;
    i    : BYTE;
    
  BEGIN
    GOTOXY( 6, 24 );
    TEXTCOLOR( LIGHTCYAN );
    IF ( percent < 10 ) THEN
      WRITE( '  ' )
    ELSE IF ( percent < 100 ) THEN
      WRITE( ' ' );
    WRITE( percent, '% fertig' );

    full := ( 55 * percent) DIV 100;
    GOTOXY( 19, 24 );
    TEXTCOLOR( YELLOW );
    FOR i := 1 TO full DO
      WRITE( #219 );
    TEXTCOLOR( LIGHTGRAY );
    FOR i := ( full + 1 ) TO 55 DO
      WRITE( #176 );

  END;


PROCEDURE clear;
  VAR
    i : BYTE;

  BEGIN
    FOR i := 1 TO 5 DO
      BEGIN
        GOTOXY( 14, 7 + i );
        WRITE( #32 );

      END;

  END;


PROCEDURE activity( index : BYTE );
  VAR
    i : BYTE;

  BEGIN
    TEXTCOLOR( LIGHTCYAN );
    CASE index OF
      1 : BEGIN
            clear;
            GOTOXY( 14, 8 );
            WRITE( #175 );

          END;

      2 : BEGIN
            GOTOXY( 14, 8 );
            WRITE( #4 );
            GOTOXY( 14, 9 );
            WRITE( #175 );

          END;

      3 : BEGIN
            GOTOXY( 14, 9 );
            WRITE( #4 );
            GOTOXY( 14, 10 );
            WRITE( #4 );
            GOTOXY( 14, 11 );
            WRITE( #175 );

          END;

      4 : BEGIN
            GOTOXY( 14, 11 );
            WRITE( #4 );
            GOTOXY( 14, 12 );
            WRITE( #175 );

          END;

    END;

  END;


PROCEDURE background;
  VAR
    i : BYTE;
    
  BEGIN
    TEXTBACKGROUND( BLUE );
    CLRSCR;

    { header }
    GOTOXY( 6, 3 );
    TEXTCOLOR( LIGHTCYAN );
    WRITE( 'Microsoft ScanDisk' );
    line( 4 );
    GOTOXY( 6, 6 );
    TEXTCOLOR( LIGHTGRAY );
    WRITE( 'ScanDisk untersucht folgende Bereiche von Laufwerk' );

    { activities }
    GOTOXY( 19,8 );
    TEXTCOLOR( LIGHTGRAY );
    WRITE( 'Datentrger-Beschreibung' );
    GOTOXY( 19, 9 );
    WRITE( 'Dateizuordnungstabellen' );
    GOTOXY( 19, 10 );
    WRITE( 'Verzeichnisstruktur' );
    GOTOXY( 19, 11 );
    WRITE( 'Dateisystem' );
    GOTOXY( 19, 12 );
    WRITE( 'Freier Speicherplatz' );
    GOTOXY( 19, 13 );
    WRITE( 'Oberflchenanalyse' );

    { anhalten button  }
    GOTOXY( 6, 21 );
    TEXTCOLOR( WHITE );
    TEXTBACKGROUND( LIGHTGRAY );
    WRITE( #17 );
    WRITE( ' Anhalten ' );
    WRITE( #16 );
    TEXTCOLOR( DARKGRAY );
    TEXTBACKGROUND( BLUE );
    WRITE( #220 );
    GOTOXY( 7, 22 );
    FOR i := 1 TO 12 DO
      WRITE( #223 );

    { details button  }
    GOTOXY( 21, 21 );
    TEXTCOLOR( DARKGRAY );
    TEXTBACKGROUND( LIGHTGRAY );
    WRITE( #60 );
    TEXTCOLOR( WHITE );
    WRITE( ' D' );
    TEXTCOLOR( DARKGRAY );
    WRITE( 'etails ' );
    WRITE( #62 );
    TEXTCOLOR( DARKGRAY );
    TEXTBACKGROUND( BLUE );
    WRITE( #220 );
    GOTOXY( 22, 22 );
    FOR i := 1 TO 11 DO
      WRITE( #223 );

    { beenden button  }
    GOTOXY( 35, 21 );
    TEXTCOLOR( DARKGRAY );
    TEXTBACKGROUND( LIGHTGRAY );
    WRITE( #60 );
    TEXTCOLOR( WHITE );
    WRITE( ' B' );
    TEXTCOLOR( DARKGRAY );
    WRITE( 'eenden ' );
    WRITE( #62 );
    TEXTCOLOR( DARKGRAY );
    TEXTBACKGROUND( BLUE );
    WRITE( #220 );
    GOTOXY( 36, 22 );
    FOR i := 1 TO 11 DO
      WRITE( #223 );

    { bottom }
    TEXTCOLOR( LIGHTCYAN );
    line( 23 );
  END;


PROCEDURE exit;
  BEGIN
    { back to default }
    TEXTCOLOR( LIGHTGRAY );
    TEXTBACKGROUND( BLACK );
    CLRSCR;
    HALT;

  END;


PROCEDURE drive( letter : CHAR );
  VAR
    i, j : BYTE;

  BEGIN
    GOTOXY( 57, 6 );
    TEXTCOLOR( LIGHTGRAY );
    WRITE( UPCASE( letter), ':' );

    FOR i := 1 TO 4 DO
      BEGIN
        activity( i );
        j := 1;
        REPEAT
          IF ( KEYPRESSED AND ( READKEY = #27 ) ) THEN
            exit;
          IF ( j <= 100 ) THEN
            BEGIN
              progressbar( j );
              GOTOXY( 46, 21 ); { sends cursor to sleep }
              DELAY( 8 );
              j := TRUNC( j + 1 /( RANDOM( 9 ) + 1 ) );
              
            END;
            
        UNTIL ( j >= 100 );
        progressbar( 100 );
        DELAY( 100 );

      END;

  END;


BEGIN
  RANDOMIZE;
  background;
  REPEAT
    drive( 'C' );
    drive( 'D' );

  UNTIL ( KEYPRESSED AND ( READKEY = #27 ) );
  exit;

END.